package com.infinity.bpm.ui;


import java.util.Iterator;

import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.BeanPostProcessor;

import com.infinity.bpm.portal.common.PerspectiveDefinition;
import com.infinity.bpm.portal.common.ViewDefinition;

public class PortalUiInitialization implements BeanPostProcessor {

	public Object postProcessAfterInitialization(Object bean, String beanName)
			throws BeansException {

		try {

			if (beanName.equals("ippBccPerspective") && bean instanceof PerspectiveDefinition) {
				PerspectiveDefinition perspective = (PerspectiveDefinition) bean;
				perspective.setRequiredRoles("Internal");
				
				for (Iterator<ViewDefinition> _iterator = perspective.getViews().iterator(); _iterator.hasNext();)
				{
					ViewDefinition view = _iterator.next();
					if (view.getName().equals("processOverviewView") || view.getName().equals("processSearchView"))
					{
						view.setRequiredRoles("Internal,External");
					}
					else
					{
						view.setRequiredRoles("Internal");
					}
				}
			}
			
			if (beanName.equals("aoBccPerspective") && bean instanceof PerspectiveDefinition) {
				PerspectiveDefinition perspective = (PerspectiveDefinition) bean;
				perspective.setRequiredRoles("External");
			}
			
			

		} catch (Exception e) {
			throw new RuntimeException(e);
		}

		return bean;
	}

	public Object postProcessBeforeInitialization(Object bean, String beanName)
			throws BeansException {

		return bean;
	}

}
